---
title: transform-box
slug: Web/CSS/transform-box
tags:
  - CSS
  - CSS Property
  - CSS Transforms
  - Experimental
  - NeedsExample
  - Reference
  - 'recipe:css-property'
---
<div>{{CSSRef}}</div>

<p>The <strong><code>transform-box</code></strong> CSS property defines the layout box to which the {{cssxref("transform")}} and {{cssxref("transform-origin")}} properties relate.</p>

<pre class="brush:css no-line-numbers notranslate">/* Keyword values */
transform-box: content-box;
transform-box: border-box;
transform-box: fill-box;
transform-box: stroke-box;
transform-box: view-box;

/* Global values */
transform-box: inherit;
transform-box: initial;
transform-box: unset;
</pre>

<h2 id="Syntax">Syntax</h2>

<p>The <code>transform-box</code> property is specified as one of the keyword values listed below.</p>

<h3 id="Values">Values</h3>

<dl>
 <dt><code>content-box</code></dt>
 <dd>
 <p>The content box is used as the reference box. The reference box of a {{htmlElement("table")}} is the border box of its table wrapper box, not its table box.</p>
 </dd>
 <dt><code>border-box</code></dt>
 <dd>The border box is used as the reference box. The reference box of a {{htmlElement("table")}} is the border box of its table wrapper box, not its table box.</dd>
 <dt><code>fill-box</code></dt>
 <dd>The object bounding box is used as the reference box.</dd>
 <dt><code>stroke-box</code></dt>
 <dd>The stroke bounding box is used as the reference box.</dd>
 <dt><code>view-box</code></dt>
 <dd>The nearest {{Glossary("SVG")}} viewport is used as the reference box. If a {{SVGAttr("viewBox")}} attribute is specified for the SVG viewport creating element, the reference box is positioned at the origin of the coordinate system established by the <code>viewBox</code> attribute, and the dimension of the reference box is set to the width and height values of the <code>viewBox</code> attribute.</dd>
</dl>

<h2 id="Formal_definition">Formal definition</h2>

<p>{{CSSInfo}}</p>

<h2 id="Formal_syntax">Formal syntax</h2>

<pre class="syntaxbox notranslate">{{csssyntax}}</pre>

<h2 id="Examples">Examples</h2>

<h3 id="SVG_transform-origin_scoping">SVG transform-origin scoping</h3>

<p>In this example we have an SVG:</p>

<pre class="brush: html notranslate">&lt;svg id="svg" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 50 50"&gt;
  &lt;g&gt;
    &lt;circle id="center" fill="red" r="1" transform="translate(25 25)" /&gt;
    &lt;circle id="boxcenter" fill="blue" r=".5" transform="translate(15 15)" /&gt;
    &lt;rect id="box" x="10" y="10" width="10" height="10" rx="1" ry="1" stroke="black" fill="none" /&gt;
  &lt;/g&gt;
&lt;/svg&gt;</pre>

<p>In the CSS we have an animation that uses a transform to rotate the rectangle infinitely. <code>transform-box: fill-box</code> is used to make the <code>transform-origin</code> the center of the bounding box, so the rectangle spins in place. Without it, the transform origin is the center of the SVG canvas, and so you get a very different effect.</p>

<pre class="brush: css notranslate">svg{
  width:80vh;
  border:1px solid #d9d9d9;
  position:absolute;
  margin: auto;
  top: 0;
  right: 0;
  bottom: 0;
  left: 0;
}

#box{
  transform-origin:50% 50%;
  /*+++++++++++++++++++++++++++*/
  /* if I remove this rule the pen won't work properly on Chrome for Mac, FF, Safari
  Will still work properly on Chrome for PC &amp; Opera*/
  transform-box: fill-box;
  /*Alternatively  I can use transform-origin:15px 15px;*/
  /*+++++++++++++++++++++++++++*/
  animation: rotateBox 3s linear infinite;
}

@keyframes rotateBox {
  to {
    transform: rotate(360deg);
  }</pre>

<p>Full credit for this example goes to <a href="https://codepen.io/giaco">Pogany</a>; see <a href="https://codepen.io/giaco/pen/OwowJQ">this codepen</a> for a live version.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('CSS3 Transforms', '#transform-box', 'transform-box')}}</td>
   <td>{{Spec2('CSS3 Transforms')}}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("css.properties.transform-box")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/CSS/Using_CSS_transforms">Using CSS transforms</a></li>
 <li>{{cssxref("transform")}}, {{cssxref("transform-origin")}}</li>
</ul>
